﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;

namespace TestThinkGeo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    /// 
    public class TestClass
    {
        public TestClass()
        {

        }
        double x;
        double y;
    }

    public partial class MainWindow : Window
    {

        //List<ObservableCollection<TestClass>> testlist;
        ObservableCollection<Button> testlist2;
        public MainWindow()
        {
            InitializeComponent();
           // testlist = new List<ObservableCollection<TestClass>>();
            testlist2 = new ObservableCollection<Button>();
            
        }

        private void wpfMap_Loaded(object sender, RoutedEventArgs e)
        {
            LoadTestData();
        }


        void LoadTestData()
        {

            RectangleShape regionExtent;
            wpfMap.MapUnit = GeographyUnit.Meter;
            
            //wpfMap.CurrentExtent = new RectangleShape(-133.2515625, 89.2484375, 126.9046875, -88.290625);

            //WorldMapKitWmsWpfOverlay worldMapKitOverlay = new WorldMapKitWmsWpfOverlay();
            //wpfMap.Overlays.Add(worldMapKitOverlay);

            string filename = @"H:\DHM\_EcoVis\Layers\Paddock Boundary Layers\Brian_Pastures_paddocks - Copy.shp";
            string filename2 = @"H:\DHM\_EcoVis\Layers\Paddock Boundary Layers\Brian_Pastures_paddocks - Copy.prj";
            ShapeFileFeatureLayer shapefl = new ShapeFileFeatureLayer(filename);
            shapefl.Open();

            string prjFileText = System.IO.File.ReadAllText(filename2); //get the text of the .prj file.
            Proj4Projection projection = new Proj4Projection();
            projection.InternalProjectionParametersString = Proj4Projection.ConvertPrjToProj4(prjFileText);
            projection.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
            shapefl.FeatureSource.Projection = projection;
            try
            {
                projection.Open();
                regionExtent = shapefl.GetBoundingBox();
            }
            finally
            {
                if (projection.IsOpen)
                    projection.Close();
            }


            shapefl.Close();
            shapefl.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));
            shapefl.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            wpfMap.CurrentExtent = regionExtent;


            LayerOverlay staticOverlay = new LayerOverlay();
            staticOverlay.TileType = TileType.MultipleTile;
            staticOverlay.Layers.Add("WorldShapeLayer", shapefl);
            //staticOverlay.TileCache = new FileBitmapTileCache(@"c:\temp");
            //staticOverlay.TileCache.CacheId = "cache";

            wpfMap.Overlays.Add(staticOverlay);


            LayerOverlay overlay = wpfMap.Overlays[0] as LayerOverlay;
            ShapeFileFeatureLayer featureLayer = overlay.Layers[0] as ShapeFileFeatureLayer;
            featureLayer.Open();
            Collection<Feature> features = featureLayer.QueryTools.GetAllFeatures(ReturningColumnsType.AllColumns);
            featureLayer.Close();


                      

            wpfMap.TrackOverlay.TrackMode = TrackMode.None;
            foreach (Feature feature in features)
            {
                wpfMap.EditOverlay.EditShapesLayer.InternalFeatures.Add(feature);
            }

         //   overlay.IsVisible = false;
            wpfMap.TrackOverlay.TrackShapeLayer.InternalFeatures.Clear();
            wpfMap.EditOverlay.CalculateAllControlPoints();

            wpfMap.Refresh();
        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            if (checkBox.IsChecked==true)
            {
                for (int i = 0; i < 1000000; ++i)
                {
                  
                    testlist2.Add(new Button());
                }
            }
            else
            {
                
                testlist2.Clear();
            }
        }
    }
}
